; TIP1148.LSP: MATCHLAY.LSP   Change Entity's Layer   (c)1995, Algis Kibirkstis

(defun C:MATCHLAY (/ $LAYER $OSMODE DTYPE E EL XEL EN XEN ET XET MSG
  NLAY PK PKLAY XPKLAY PLUR SEL SET SETL XT)
  (setq XT nil)
  (setq $LAYER (getvar "CLAYER"))
  (setq $OSMODE (getvar "OSMODE"))
  (setq SET (ssget))
  (setq SETL (sslength SET))
  (if (> SETL 1)
    (setq PLUR "s")
    (setq PLUR "" )
  )
  (menucmd "s=matchlay")
  (initget 128)
  (setvar "OSMODE" 512)
  (setq PK (getpoint
    "\nInput Layer name, Select Entity, or <Enter> for Current Layer: ")
  )
  (setvar "OSMODE" $OSMODE)
  (setq DTYPE (type PK))
  (if (= DTYPE nil)
    (setq NLAY $LAYER)
    (if (= DTYPE 'LIST)
      (progn
        (setq E (nentselp PK))
        (setq EN (car (cadddr E)))
        (if (/= EN nil)
          (progn
            (setq XT (type EN))
            (setq EL (entget EN))
            (setq ET (cdr (assoc '0 EL)))
            (setq PKLAY (cdr (assoc '8 EL)))
          )
        )
        (setq XEN (car E))
        (setq XEL (entget XEN))
        (setq XET (cdr (assoc '0 XEL)))
        (setq XPKLAY (cdr (assoc '8 XEL)))
        (if (or (eq XET "ATTRIB") (= XT 'ENAME))
          (progn
            (if (eq XET "ATTRIB")
              (progn
                (while (/= XET "SEQEND")
                  (setq XEN (entnext XEN))
                  (setq XEL (entget XEN))
                  (setq XET (cdr (assoc '0 XEL)))
                )
                (setq PKLAY (cdr (assoc '8 XEL)))
              )
            )
            (print)
            (alert "Nested Entity selected")
            (setq MSG
              (strcat "\nPress PICK button for Block Layer \"" PKLAY
                "\", or <Enter> for Subentity Layer \"" XPKLAY "\": "
              )
            )
            (setq SEL (getpoint MSG))
            (if (= SEL nil)
              (setq NLAY XPKLAY)
              (setq NLAY PKLAY)
            )
          )
          (setq NLAY XPKLAY)
        )
      )
      (setq NLAY PK)
    )
  )
  (menucmd "s=")
  (command "change" SET "" "p" "layer" NLAY "")
  (print)
  (prompt (strcat "\nElement" PLUR " changed to Layer \"" NLAY "\"."))
  (prin1)
); end matchlay.lsp
