; TIP1149.LSP: ORG.LSP    Original Dimension    (c)1995, D.A. Longhenry

(defun item ( A B ) (cdr (assoc A B)) )
;
(defun C:ORG ( / SS CNT EN )
  ;*Save current values
  (setq OLD_ECHO (getvar "CMDECHO")
    OLD_SNAP (getvar "SNAPMODE")
  );end setq

  ;*Set new setvars
  (setvar "CMDECHO" 0)
  (setvar "SNAPMODE" 0)

  ;*Get selection set
  (setq SS (ssget)
    CNT 0
  );end setq

  ;*Reset to default value if entity is a dimension
  (repeat (sslength SS)
    (setq EN (entget (ssname SS CNT))
      CNT (1+ CNT)
    );end setq
    (if (= (item 0 EN) "DIMENSION")
      (entmod (subst (cons 1 "") (assoc 1 EN) EN) )
    );end if
  );end repeat

  ;*Reset setvars to old values
  (setvar "CMDECHO" OLD_ECHO)
  (setvar "SNAPMODE" OLD_SNAP)
  (princ)
)
(princ);end org.lsp
