; TIP1151.LSP: SLIDE.LSP   Slide Show   (c)1995, Andrew Campbell 

(defun C:SLIDE ()
  (setq SLD_FILE "c:/0hth_try/slide.dat")  ; name of file containing slide list
  (setq S_COUNT (count_slides)); number of slides (lines) in sld_file
  (setq L_COUNT 1)             ; current line count read by routine, initially
  (getslide)
  (options)
)

; Count Line Length of sld_file --------------------------------
(defun count_slides ()
  (setq LINE "value")
  (setq L_COUNT -1)
  (setq S_FILE (open SLD_FILE "r"))
  (while (/= LINE nil)
    (setq L_COUNT (1+ L_COUNT))
    (setq LINE (read-line S_FILE))
  ) ;end while
  (close S_FILE)
  l_count
)

; Select Next Slide from File-----------------------------------
(defun getslide ()
  (setq S_FILE (open SLD_FILE "r"))    
  (setq COUNTER1 0)
  (while (/= COUNTER1 L_COUNT)
    (setq COUNTER1 (1+ COUNTER1))
    (setq LINE (read-line S_FILE))
    (setq C_SLIDE (substr LINE 1 12))
  ) ;end while
  (command "vslide" C_SLIDE)
  (close S_FILE)
)
; Define Projector Options--------------------------------------
(defun options ()   
  (setq ANS "T")             
  (while (/= ANS "Q")           
    (initget 1 "F R Q")
    (setq ANS (getkword "(F)orward (R)everse (Q)uit: "))

    (if (= ANS "F")
      (progn
        (setq L_COUNT (1+ L_COUNT)) 
        (chk_count)
        (getslide)
      ) ;end progn
    ) ;end if

    (if (= ANS "R")
      (progn
        (setq L_COUNT (1- L_COUNT))  
        (chk_count)
        (getslide)  
      ) ;end progn
    ) ;end if

    (if (= ANS "Q")
      (command "redraw")
    ) ;end if

  ) ;end while
)

; Check if at End or Beginning of sld_file----------------------
(defun chk_count ()
  (if  (> L_COUNT S_COUNT) ; over
    (setq L_COUNT 1)
  ) ;end if

  (if (< L_COUNT 1)       ; under
    (setq L_COUNT S_COUNT)
  ) ;end if
)
(princ); end slide.lsp 
