; TIP1146.LSP: CNC.LSP    CNC Code    (c)1995, Douglas Newton

(defun lcd (/ END1 END2 TAR)
   (setq END1 (cdr (assoc 10 EN)))
   (setq END2 (cdr (assoc 11 EN)))
   (if (equal END1 TPOS 0.001)(setq TAR END2) (setq TAR END1))
   (if (= (cdr (assoc 8 EN)) "RAPID") (princ "\nG00" F) (princ "\nG01" F))
   (if (not (equal (car TPOS) (car TAR) 0.0005))
      (progn
         (princ "X" F)
         (princ (car TAR) F)
      )
   )
   (if (not (equal (cadr TPOS) (cadr TAR) 0.0005))
      (progn
         (princ "Y" F)
         (princ (cadr TAR) F)
      )
   )
   (if (not (equal (caddr TPOS) (caddr TAR) 0.0005))
      (progn
         (princ "Z" F)
         (princ (caddr TAR) F)
      )
   )
   (setq TPOS TAR)
)

(defun ARCD(/ XC YC ZC RD AG1 AG2 I1 J1 ARS ARE TAR I J)
   (setq ACN (cdr(assoc 10 EN)))
   (setq XC (car ACN))
   (setq YC (cadr ACN))
   (setq ZC (caddr ACN))
   (setq RD (cdr (assoc 40 EN)))
   (setq AG1 (cdr (assoc 50 EN)))
   (setq AG2 (cdr (assoc 51 EN)))
   (setq I1 (* RD (cos AG1)))
   (setq J1 (* RD (sin AG1)))
   (setq ARS (list (+ XC I1)(+ YC J1) ZC))
   (setq I2 (* RD (cos AG2)))
   (setq J2 (* RD (sin AG2))) 
   (setq ARE (list (+ XC I2)(+ YC J2) ZC))
   (if (equal TPOS ARS 0.0005)(setq TAR ARE)(setq TAR ARS))
   (setq RD (distance TPOS ACN))
   (setq AGL  (angle TPOS ACN))
   (setq I (* rd (cos AGL)))
   (setq J (* rd (sin AGL)))
   (if (= TAR ARE) (princ  "\nG03" F) (princ "\nG02" F))
   (princ "X" F)
   (princ (car TAR) F)
   (princ "Y" F)
   (princ (cadr TAR) F)
   (if (not (equal I 0.0 0.0001))
      (progn
         (princ "I" F)
         (princ I F)
      )
   )
   (if (not (equal J 0.0 0.0001))
      (progn
         (princ "J" F)
         (princ j F)
      )
   )
   (setq TPOS TAR)
)

(defun cment()
   (if (= (strcase CMT) "C")
      (progn
         (setq CMT (getstring t "\nEnter comment:   "))
         (princ "\n*"  F)
         (princ CMT F)
         (setq CMT (getstring "\nReturn to continue or E-exit:  "))
      )
   ) 
   (if(= (strcase CMT) "E") (setq CMT T))
)

(defun C:CNC (/ SE CDF )
   (setq CMT "")
   (setq CDF (getstring "\nOutput file name:  " ))
   (setq TPOS (getpoint "\nSnap to start of cutter path:  "))
   (setq F (open CDF "a"))
   (princ "\nPath start " F)
   (princ TPOS F)
   (while (= CMT "")
      (setq SE (entsel"\nselect arc or line:   "))
      (setq EN (entget (car SE )))
      (redraw (car SE) 3)  
      (cond
         ((= "LINE" (cdr (assoc 0 EN))) (LCD)) 
         ((= "ARC" (cdr (assoc 0 eN))) (ARCD))
         (EN (prompt "not a line or arc  "))
      )
      (setq CMT (getstring "\nc-comment e-end return for entity:   "))
      (if (/= CMT "") (CMENT))   
   )
   (close F)
   (redraw)
); end cnc.lsp 
