; TIP1147.LSP: DASCII.LSP    View ASCII Files    (c)1995, Frank J. Zakrajsek

(defun C:DASCII ( / FILENAME NAME1 TITLE FH DO_WHAT INDEX)
  (setq NAME1 (getfiled "Select an ASCII file to display: " "" "" 8))
  ;; display the getfiled dialog box.
  (setq NN NAME1)
  (if NAME1
    (progn
      ;; write the ascii.dcl file to the drive.
      (setq FILENAME (findfile NAME1))
      (setq TITLE (strcat "Ascii File Display < " NAME1 " >" ))
      (setq FH (open "ASCII.dcl" "w"))
      (if FH
        (progn
          (write-line         "ascii : dialog {"     fh)
          (write-line (strcat "   label =\"" title "\";")     fh)
          (write-line         "  : list_box {"     fh)
          (write-line         "       key = \"b_bom\" ;" fh)
          (write-line         "     width = 75;"     fh) ;;width
          (write-line         "    height = 20;"     fh) ;;height
          (write-line         "             }"     fh)
          (write-line         ": boxed_row {"     fh)
          (write-line         "  : button {"     fh)
          (write-line         " alignment = centered; "     fh)
          (write-line         "       key = \"print\" ;" fh)
          (write-line         "     label = \"Print Report\" ;" fh)       
          (write-line         " fixed_width = true;"     fh)       
          (write-line         "     width = 25;"     fh)
          (write-line         "             }"     fh)
          (write-line         "   ok_cancel ;" fh)
          (write-line         "  }" fh)
          (write-line         "}" fh)
          (setq fh (close fh))
        )
        (alert "Could not create the ASCII Dialog Box!")
      );if fh

      ;; load the ascii.dcl dialog box
      (if (> (setq INDEX (load_dialog "ascii.dcl")) 0)
        (progn
          (setq DO_WHAT 4)
          ;; display the dialog box within a while loop.
          (while (> DO_WHAT 1)
            (if (new_dialog "ascii" INDEX)
              (progn
                ;; read the file and put it into a list.
                (start_list "b_bom")
                (mapcar 'add_list (readfile FILENAME))
                (end_list)
                (action_tile "print" "(done_dialog 3)")
                (setq do_what (start_dialog))

                (cond
                  ((= DO_WHAT 3)
                    ;; copy the filename to the selected port.
                    (setq NNN (strcat "Copy " FILENAME " lpt1"))   
                  (command ".shell" NNN))
                  ((= DO_WHAT 1)
                    ;; okay button pressed.
                    (setq DO_WHAT 0)
                    (done_dialog 1)
                    (C:DASCII)
                  )
                );cond
              )
              (progn
                (prompt "Unable to display dialog box")

              )
            );if new dialog

          )
          (unload_dialog index) ; unload the dialog box
        )
        (prompt "Unable to load dialog box")
      );if dialog


    )
  );if 
  (princ)
)

;;-----------------------------------------------------------------
;; Readfile     Create a list of an ascii file...
;;-----------------------------------------------------------------
;;
(defun readfile (FNAME / FFP TOTLST TXTLINE)
  (setq TOTLST nil
  FFP (open fname "r"))
  (while FFP
    (setq TXTLINE (read-line FFP))
    (if TXTLINE
      (setq TOTLST (cons TXTLINE TOTLST))
      (setq FFP (close FFP))
    );if
  );while
  (setq TOTLST (reverse TOTLST))
  TOTLST                                 ;return the total list.
)
(princ); end dascii.lsp
